/* ************************************************************************** */
/*                                       _____           _                    */
/*  libp7/internals/packetio.h          |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : libp7                     | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/08/17 18:09:04                               |___/     */
/*                                                                            */
/* ************************************************************************** */

#ifndef LIBP7_INTERNALS_PACKETIO_H
# define LIBP7_INTERNALS_PACKETIO_H
# include <libp7/internals/packet.h>

/* ************************************************************************** */
/*  Packet sending                                                            */
/* ************************************************************************** */
/* Commands */
int p7_send_cmdsys_reset(void);
int p7_send_cmdsys_getinfo(void);
int p7_send_cmdsys_setlink(unsigned int baudrate, int parity, int stopbits);
int p7_send_cmdfls_reqfile(char *dirname, char *filename, char *devname);
int p7_send_cmdfls_sendfile(p7_commandoverwrite_t ow, unsigned int fs,
	char *dirname, char *filename, char *devname);
int p7_send_cmdfls_delfile(char *dirname, char *filename, char *devname);

/* Data */
int p7_send_data(unsigned int total, unsigned int id,
	void *data, unsigned int datasize);

/* Errors */
int p7_send_err_resend(void);
int p7_send_err_overwrite_no(void);

/* Acknowledgements */
int p7_send_ack(void);
int p7_send_ack_confirm_ow(void);
int p7_send_ack_ext(void *data, unsigned int datasize);

/* Checks */
int p7_send_check(int meanwhile);

/* Roleswap */
int p7_send_roleswp(void);

/* Terminations */
int p7_send_term(void);
int p7_send_term_usr(void);
int p7_send_term_timeout(void);
int p7_send_term_overwrite(void);

/* ************************************************************************** */
/*  Packet receiving                                                          */
/* ************************************************************************** */
/* General */
int p7_receive(p7_packet_t *packet);

/* Specific to active and passive sides */
int p7_receive(p7_packet_t *packet); /* active */
int p7_listen(p7_packet_t *packet); /* passive */

#endif /* LIBP7_INTERNALS_PACKETIO_H */
